mod Maux logic: 'cl'

incl Mtex

loc rem 
  \para \bf  List membership.  \end 

lemma In_expl_conc
  x in y <-> \e z1\e z2 y = z1++(x,z2)
proof 
 ind Ln; y @ 0; v,w
  proved
  weak x in w <-> \e z1\e z2 w = z1++(x,z2)
   split* x = v \/ \e z1\e z2 w = z1++(x,z2) <-> \e z1\e z2 v,w = z1++(x,z2).2,
                                                                             (1,
                                                                              (4,
                                                                               0,
                                                                               0,
                                                                               0),
                                                                              0),
                                                                             0
    weak x = v
     inst* \e z1\e z2 v,w = z1++(v,z2); 0; w proved..
    eigen \e z1\e z2 w = z1++(x,z2); z1,z2
     weak w = z1++(x,z2)
      inst* \e z3\e z4 v,z1++(x,z2) = z3++(x,z4); v,z1; z2 proved...
    eigen \e z1\e z2 v,w = z1++(x,z2); z1,z2
     case Ln; z1 @ 0; v1,w1
      proved
      weak z1 = v1,w1
       weak v = v1
        weak* x = v1
         weak w = w1++(x,z2)
          inst* \e z1\e z3 w1++(x,z2) = z1++(x,z3); w1; z2 proved...........

rem 
  \para \bf  Counting the number of occurrences in lists.  \end 

fun/2 Count 'Tex_f2_ln_count'
  Count(a,0) = 0
  Count(a,v,w) = Count(a,w)+1 <- a = v
  Count(a,v,w) = Count(a,w) <- a != v

lemma Count_zero
  \a a Count(a,x) = 0 <-> x = 0
proof 
 case Ln; x @ 0; v,w
  proved
  weak x = v,w
   inst* ~\a a Count(a,v,w) = 0; v proved....

lemma Count_in
  a in x <-> Count(a,x) > 0
proof 
 ind Ln; x @ 0; v,w
  proved
  cut a = v
   proved
   proved...

lemma Count_conc
  Count(a,x++y) = Count(a,x)+Count(a,y)
proof 
 ind Ln; x @ 0; v,w
  proved
  cut a = v
   proved
   proved...

lemma Count_conc_elem
  Count(a,x++(a,y)) = Count(a,x++y)+1 & 
  (a != b -> Count(a,x++(b,y)) = Count(a,x++y))
proof 
 split* Count(a,x++(a,y)) = Count(a,x++y)+1 & 
        (a != b -> Count(a,x++(b,y)) = Count(a,x++y)).4,0,0,0
  use Count_conc; a; x; a,y
   use Count_conc; a; x; y proved..
  use Count_conc; a; x; b,y
   use Count_conc; a; x; y proved....

rem 
  \para \bf  Definition and basic properties of suffix relation.  \end 

pred/2 Suffix 'Tex2_sqsupset'
  Suffix(x,y) <-> \e z x = z++y

thm Suffix_zero_left
  Suffix(0,y) <-> y = 0
proof 
 exp Suffix; 0,y
  case Ln; y @ 0; v,w
   inst* \e z z = 0; 0 proved.
   proved...

thm Suffix_pair_left
  Suffix((v,w),y) <-> y = v,w \/ Suffix(w,y)
proof 
 split* Suffix((v,w),y) <-> y = v,w \/ Suffix(w,y).2,0,1,(4,0,0,0),0
  exp Suffix; (v,w),y
   eigen \e z v,w = z++y; z
    case Ln; z @ 0; v1,w1
     proved
     exp Suffix; w1++y,y
      inst* \e z1 w1 = z1; w1 proved.....
  weak y = v,w
   exp Suffix; (v,w),v,w
    inst* \e z z = 0; 0 proved...
  exp Suffix; w,y
   eigen \e z w = z++y; z
    weak w = z++y
     exp Suffix; (v,z++y),y
      inst* \e z1 z1 = v,z; v,z proved.......

rem 
  \para \bf  Definition and basic properties of prefix relation.  \end 

pred/2 Prefix 'Tex2_sqsubset'
  Prefix(y,x) <-> \e z x = y++z

thm Prefix_zero_right
  Prefix(y,0) <-> y = 0
proof 
 split* Prefix(y,0) <-> y = 0.2,0,0
  exp Prefix; y,0 proved.
  weak y = 0
   exp Prefix; 0,0
    inst* \e z z = 0; 0 proved.....

thm Prefix_pair_right
  Prefix(y,v,w) <-> y = 0 \/ \e z(Prefix(z,w) & y = v,z)
proof 
 split* Prefix(y,v,w) <-> y = 0 \/ \e z(Prefix(z,w) & y = v,z).2,0,1,(4,0,0,0),0
  exp Prefix; y,v,w
   eigen \e z v,w = y++z; z
    case Ln; y @ 0; v1,w1
     proved
     inst* \e z1(Prefix(z1,w1++z) & w1 = z1); w1
      weak* \e z1(Prefix(z1,w1++z) & w1 = z1)
       exp Prefix; w1,w1++z
        inst* \e z1 z = z1; z proved.......
  weak y = 0
   exp Prefix; 0,v,w
    inst* \e z v,w = z; v,w proved...
  eigen \e z(Prefix(z,w) & y = v,z).0; z
   weak y = v,z
    exp Prefix; (v,z),v,w
     exp Prefix; z,w proved......

rem 
  \para \bf  Definition and basic properties of segments.  \end 

pred/2 Segment 'Tex2_subset'
  Segment(y,x) <-> \e z1\e z2 x = z1++y++z2

thm Segment_zero_right
  Segment(y,0) <-> y = 0
proof 
 split* Segment(y,0) <-> y = 0.2,0,0
  exp Segment; y,0 proved.
  weak y = 0
   exp Segment; 0,0
    inst* \e z2 z2 = 0; 0 proved.....

thm Segment_pair_right
  Segment(y,v,w) <-> \e z(Prefix(z,w) & y = v,z) \/ Segment(y,w)
proof 
 split* Segment(y,v,w) <-> \e z(Prefix(z,w) & y = v,z) \/ Segment(y,w).2,0,1,
                                                                       (4,0,0,0),
                                                                       0
  exp Segment; y,v,w
   eigen \e z1\e z2 v,w = z1++y++z2; z1,z2
    case Ln; z1 @ 0; v1,w1
     case Ln; y @ 0; v1,w1
      exp Segment; 0,w
       inst* \e z3\e z4 w = z3++z4; 0; w proved..
      inst* \e z(Prefix(z,w1++z2) & w1 = z); w1
       exp Prefix; w1,w1++z2
        inst* \e z z2 = z; z2 proved....
     exp Segment; y,w1++y++z2
      inst* \e z3\e z4 w1++y++z2 = z3++y++z4; w1; z2 proved.....
  eigen \e z(Prefix(z,w) & y = v,z).0; z
   exp Prefix; z,w
    eigen \e z1 w = z++z1; z1
     exp Segment; (v,z),v,z++z1
      inst* \e z2\e z3 v,z++z1 = z2++(v,z++z3); 0; z1 proved.....
  exp Segment; y,w
   eigen \e z1\e z2 w = z1++y++z2; z1,z2
    exp Segment; y,v,z1++y++z2
     inst* \e z3\e z4 v,z1++y++z2 = z3++y++z4; v,z1; z2 proved......

rem 
  \para \bf  Definition and basic properties of subsequences.  \end 

pred/2 Subsq1 
  Subsq1(y,0) <- y = 0
  Subsq1(y,v1,w1) <- y = 0
  Subsq1(y,v1,w1) <- y = v2,w2 & v2 = v1 & Subsq1(w2,w1)
  Subsq1(y,v1,w1) <- y = v2,w2 & v2 != v1 & Subsq1(y,w1)

pred/2 Subsq 'Tex2_triangleleft'
  Subsq(y,x) <-> Subsq1(y,x)

lemma Subsq1_refl
  Subsq1(x,x)
proof 
 ind Ln; x @ 0; v,w
  proved
  proved..

lemma Subsq1_zero_right
  Subsq1(x,0) <-> x = 0
proof  proved.

lemma Subsq1_pair_left
  Subsq1((a,x),y) -> Subsq1(x,y)
proof 
 ind Ln; y; a,x @ 0; v2,w2
  proved
  case Ln; x @ 0; v1,w1
   proved
   cut v1 = v2
    cut a = v2
     inst \a x(\e aSubsq1((a,x),w2) -> Subsq1(x,w2)):0,2,0,1; w1; v2 proved.
     inst \a x(\e aSubsq1((a,x),w2) -> Subsq1(x,w2)):0,2,0,1; v2,w1; a
      inst \a x(\e aSubsq1((a,x),w2) -> Subsq1(x,w2)):0,2,0,1; w1; v2 proved...
    cut a = v2
     proved
     inst \a x(\e aSubsq1((a,x),w2) -> Subsq1(x,w2)):0,2,0,1; v1,w1; a proved......

lemma Subsq1_trans
  Subsq1(x,y) & Subsq1(y,z) -> Subsq1(x,z)
proof 
 ind Ln; z; x,y @ 0; v3,w3
  proved
  case Ln; y @ 0; v2,w2
   proved
   case Ln; x @ 0; v1,w1
    proved
    cut v1 = v3
     cut v2 = v3
      inst \a x(\e y(Subsq1(x,y) & Subsq1(y,w3)) -> Subsq1(x,w3)):0,2,0,1; w1; w2 proved.
      use Subsq1_pair_left; v3; w1; w2
       use Subsq1_pair_left; v2; w2; w3
        inst \a x(\e y(Subsq1(x,y) & Subsq1(y,w3)) -> Subsq1(x,w3)):0,2,0,1; w1; w2 proved....
     cut v1 = v2
      inst \a x(\e y(Subsq1(x,y) & Subsq1(y,w3)) -> Subsq1(x,w3)):0,2,0,1; v2,w1; v2,w2 proved.
      cut v2 = v3
       inst \a x(\e y(Subsq1(x,y) & Subsq1(y,w3)) -> Subsq1(x,w3)):0,2,0,1; v1,w1; w2 proved.
       use Subsq1_pair_left; v2; w2; w3
        inst \a x(\e y(Subsq1(x,y) & Subsq1(y,w3)) -> Subsq1(x,w3)):0,2,0,1; v1,w1; w2 proved.........

lemma Subsq1_pair_right
  Subsq1(x,y) -> Subsq1(x,a,y)
proof 
 ind Ln; y; x,a @ 0; v2,w2
  proved
  case Ln; x @ 0; v1,w1
   proved
   cut v1 = a
    cut a = v2
     inst \a x(Subsq1(x,w2) -> \a aSubsq1(x,a,w2)):0,2,1,0; w1; v2 proved.
     use Subsq1_pair_left; a; w1; w2
      inst \a x(Subsq1(x,w2) -> \a aSubsq1(x,a,w2)):0,2,1,0; w1; v2 proved...
    proved....

lemma Subsq1_pair_left_not
  ~Subsq1((a,x),x)
proof 
 ind Ln; x; a @ 0; v,w
  proved
  cut a = v
   inst \a a~Subsq1((a,w),w); v proved.
   inv* ~Subsq1((a,v,w),w)
    use Subsq1_pair_left; a; v,w; w
     inst \a a~Subsq1((a,w),w); v proved......

lemma Subsq1_antisym
  Subsq1(x,y) & Subsq1(y,x) -> x = y
proof 
 ind Ln; y; x @ 0; v2,w2
  proved
  case Ln; x @ 0; v1,w1
   proved
   cut v1 = v2
    inst \a x(Subsq1(x,w2) & Subsq1(w2,x) -> x = w2); w1 proved.
    use Subsq1_pair_left; v2; w2; w1
     use Subsq1_pair_left; v1; w1; w2
      inst \a x(Subsq1(x,w2) & Subsq1(w2,x) -> x = w2); w1
       use Subsq1_pair_left_not; v2; w2 proved........

lemma Subsq1_pair_right1
  Subsq1(y,v,w) <-> \e z(y = v,z & Subsq1(z,w)) \/ Subsq1(y,w)
proof 
 split* Subsq1(y,v,w) <-> \e z(y = v,z & Subsq1(z,w)) \/ Subsq1(y,w).2,0,1,
                                                                     (4,0,0,0),0
  case Ln; y @ 0; v1,w1
   case Ln; w @ 0; v1,w1
    proved
    proved.
   cut v1 = v
    inst* \e z(w1 = z & Subsq1(z,w)); w1 proved.
    proved..
  eigen \e z(y = v,z & Subsq1(z,w)).0; z proved.
  case Ln; y @ 0; v1,w1
   proved
   cut v1 = v
    use Subsq1_pair_left; v; w1; w proved.
    proved....

thm Subsq_refl
  Subsq(x,x)
proof 
 exp Subsq; x,x
  use Subsq1_refl; x proved...

thm Subsq_antisym
  Subsq(x,y) & Subsq(y,x) -> x = y
proof 
 exp Subsq; x,y
  exp Subsq; y,x
   use Subsq1_antisym; x; y proved....

thm Subsq_trans
  Subsq(x,y) & Subsq(y,z) -> Subsq(x,z)
proof 
 exp Subsq; x,y
  exp Subsq; y,z
   exp Subsq; x,z
    use Subsq1_trans; x; y; z proved.....

thm Subsq_pair
  Subsq(x,y) -> Subsq((a,x),a,y)
proof 
 exp Subsq; x,y
  exp Subsq; (a,x),a,y proved...

thm Subsq_zero_right
  Subsq(y,0) <-> y = 0
proof 
 exp Subsq; y,0 proved..

thm Subsq_pair_right
  Subsq(y,v,w) <-> \e z(y = v,z & Subsq(z,w)) \/ Subsq(y,w)
proof 
 split* Subsq(y,v,w) <-> \e z(y = v,z & Subsq(z,w)) \/ Subsq(y,w).2,0,1,
                                                                  (4,0,0,0),0
  exp Subsq; y,v,w
   use Subsq1_pair_right1.2,0,0; y; v; w
    split \e z(y = v,z & Subsq1(z,w)) \/ Subsq1(y,w).4,0,0,0
     eigen \e z(y = v,z & Subsq1(z,w)).0; z
      inst* \e z1(z = z1 & Subsq(z1,w)); z
       exp Subsq; z,w proved...
     exp Subsq; y,w proved....
  eigen \e z(y = v,z & Subsq(z,w)).0; z
   exp Subsq; (v,z),v,w
    exp Subsq; z,w proved...
  exp Subsq; y,v,w
   exp Subsq; y,w
    use Subsq1_pair_right1.2,1,1,(4,1,0),0; y; v; w proved.....

rem 
  \para \bf  Definition and basic properties of insertion relation.  \end 

pred/3 Inserted 'Tex_p3_ln_inserted'
  Inserted(y,x,a) <-> \e z1\e z2(x = z1++z2 & y = z1++(a,z2))

thm Inserted_zero_right
  Inserted(y,0,a) <-> y = a,0
proof 
 exp Inserted; y,0,a
  split* \e z1(\e z2(z2 = 0 & y = z1++(a,z2)) & z1 = 0) <-> y = a,0.2,0,0
   eigen \e z1(\e z2(z2 = 0 & y = z1++(a,z2)) & z1 = 0).0:0,3,0,1,0; z1,z2
    proved.
   inst* \e z2 z2 = 0; 0 proved....

thm Inserted_pair_right
  Inserted(y,(v,w),a) <-> y = a,v,w \/ \e z(Inserted(z,w,a) & y = v,z)
proof 
 split* Inserted(y,(v,w),a) <-> y = a,v,w \/ \e z(Inserted(z,w,a) & y = v,z).2,
                                                                             0,
                                                                             1,
                                                                             (4,
                                                                              0,
                                                                              0,
                                                                              0),
                                                                             0
  exp Inserted; y,(v,w),a
   eigen \e z1\e z2(v,w = z1++z2 & y = z1++(a,z2)).0; z1,z2
    case Ln; z1 @ 0; v1,w1
     proved
     inst* \e z(Inserted(z,w1++z2,a) & w1++(a,z2) = z); w1++(a,z2)
      exp Inserted; w1++(a,z2),w1++z2,a
       inst* \e z3\e z4(w1++z2 = z3++z4 & w1++(a,z2) = z3++(a,z4)); w1; z2 proved......
  weak y = a,v,w
   exp Inserted; (a,v,w),(v,w),a
    inst* \e z1\e z2(v,w = z1++z2 & a,v,w = z1++(a,z2)); 0; v,w proved...
  eigen \e z(Inserted(z,w,a) & y = v,z).0; z
   exp Inserted; z,w,a
    eigen \e z1\e z2(w = z1++z2 & z = z1++(a,z2)).0; z1,z2
     exp Inserted; (v,z1++(a,z2)),(v,z1++z2),a
      inst* \e z3\e z4(v,z1++z2 = z3++z4 & v,z1++(a,z2) = z3++(a,z4)); v,z1; z2 proved.......

rem 
  \para \bf  Definition and basic properties of permutations.  \end 

pred/2 Perm 'Tex2_sim'
  Perm(x,y) <-> \a a Count(a,x) = Count(a,y)

rem 
  \para \it  Permutation is an equivalence relation.  \end 

thm Perm_refl
  Perm(x,x)
proof 
 exp Perm; x,x proved..

thm Perm_sym
  Perm(x,y) -> Perm(y,x)
proof 
 exp Perm; x,y
  exp Perm; y,x proved...

thm Perm_trans
  Perm(x,y) & Perm(y,z) -> Perm(x,z)
proof 
 exp Perm; x,y
  exp Perm; y,z
   exp Perm; x,z
    eigen* \a a Count(a,x) = Count(a,z); a
     inst \a a Count(a,x) = Count(a,y); a
      inst \a a Count(a,y) = Count(a,z); a proved.......

rem 
  \para \it  Congruence properties of permutations.  \end 

thm Perm_pair
  Perm(x,y) -> Perm((a,x),a,y)
proof 
 exp Perm; x,y
  exp Perm; (a,x),a,y
   eigen* \a a1 Count(a1,a,x) = Count(a1,a,y); a1
    cut a1 = a
     inst \a a1 Count(a1,x) = Count(a1,y); a proved.
     inst \a a1 Count(a1,x) = Count(a1,y); a1 proved......

thm Perm_conc
  Perm(x1,y1) & Perm(x2,y2) -> Perm(x1++x2,y1++y2)
proof 
 exp Perm; x1,y1
  exp Perm; x2,y2
   exp Perm; x1++x2,y1++y2
    eigen* \a a Count(a,x1++x2) = Count(a,y1++y2); a
     use Count_conc; a; x1; x2
      use Count_conc; a; y1; y2
       inst \a a Count(a,x1) = Count(a,y1); a
        inst \a a Count(a,x2) = Count(a,y2); a proved.........

lemma Lemma_perm_in
  Perm(x,y) & a in x -> a in y
proof 
 use Count_in.0; a; y
  weak a in y <-> Count(a,y) > 0
   use Count_in.2,0,0; a; x
    weak a in x
     use Perm.2,0,0:0,2,1,0; x; y; a proved......

thm Perm_in
  Perm(x,y) -> a in x <-> a in y
proof 
 split* a in x <-> a in y.2,0,0
  use Lemma_perm_in; x; y; a proved.
  use Lemma_perm_in; y; x; a
   use Perm_sym; x; y proved....

rem 
  \para \it  Remaining properties of permutations.  \end 

lemma Perm_zero_left
  Perm(0,y) <-> y = 0
proof 
 exp Perm; 0,y
  use Count_zero.0; y proved...

thm Perm_zero_right
  Perm(y,0) <-> y = 0
proof 
 exp Perm; y,0
  use Count_zero.0; y proved...

thm Perm_exchange
  Perm((a,b,x),b,a,x)
proof 
 exp Perm; (a,b,x),b,a,x
  eigen* \a a1 Count(a1,a,b,x) = Count(a1,b,a,x); a1
   cut a1 = a
    cut a = b
     proved
     proved.
    cut a1 = b
     proved
     proved.....

thm Perm_cancel_conc_elem
  Perm(x1++(a,x2),y1++(a,y2)) <-> Perm(x1++x2,y1++y2)
proof 
 split* Perm(x1++(a,x2),y1++(a,y2)) <-> Perm(x1++x2,y1++y2).2,0,0
  exp Perm; x1++x2,y1++y2
   eigen* \a a1 Count(a1,x1++x2) = Count(a1,y1++y2); b
    cut a = b
     weak a = b
      use Perm.2,0,0:0,2,1,0; x1++(b,x2); y1++(b,y2); b
       weak Perm(x1++(b,x2),y1++(b,y2))
        use Count_conc_elem.4,0,0; b; x1; x2
         use Count_conc_elem.4,0,0; b; y1; y2 proved.....
     use Perm.2,0,0:0,2,1,0; x1++(a,x2); y1++(a,y2); b
      weak Perm(x1++(a,x2),y1++(a,y2))
       use Count_conc_elem.4,1,0; b; x1; x2; a
        use Count_conc_elem.4,1,0; b; y1; y2; a proved.......
  exp Perm; x1++(a,x2),y1++(a,y2)
   eigen* \a a1 Count(a1,x1++(a,x2)) = Count(a1,y1++(a,y2)); b
    cut a = b
     weak a = b
      use Count_conc_elem.4,0,0; b; x1; x2
       weak Count(b,x1++(b,x2)) = Count(b,x1++x2)+1
        use Count_conc_elem.4,0,0; b; y1; y2
         weak Count(b,y1++(b,y2)) = Count(b,y1++y2)+1
          use Perm.2,0,0:0,2,1,0; x1++x2; y1++y2; b proved......
     use Count_conc_elem.4,1,0; b; x1; x2; a
      weak Count(b,x1++(a,x2)) = Count(b,x1++x2)
       use Count_conc_elem.4,1,0; b; y1; y2; a
        weak Count(b,y1++(a,y2)) = Count(b,y1++y2)
         use Perm.2,0,0:0,2,1,0; x1++x2; y1++y2; b proved..........

lemma Perm_pair_left_conc
  Perm((v,w),y) <-> \e z1\e z2(y = z1++(v,z2) & Perm(w,z1++z2))
proof 
 split* Perm((v,w),y) <-> \e z1\e z2(y = z1++(v,z2) & Perm(w,z1++z2)).2,0,0
  use Perm_in.1,0,2,0,0; v,w; y; v
   use In_expl_conc.2,0,0; v; y
    weak v in y
     eigen \e z1\e z2 y = z1++(v,z2); z1,z2
      weak y = z1++(v,z2)
       use Perm_cancel_conc_elem.0; 0; v; w; z1; z2
        weak Perm((v,w),z1++(v,z2))
         inst* \e z3\e z4(z1++(v,z2) = z3++(v,z4) & Perm(w,z3++z4)); z1; z2 proved........
  eigen \e z1\e z2(y = z1++(v,z2) & Perm(w,z1++z2)).0; z1,z2
   weak y = z1++(v,z2)
    use Perm_cancel_conc_elem.0; 0; v; w; z1; z2 proved.....

lemma Perm_pair_right_conc
  Perm(x,v,w) <-> \e z1\e z2(x = z1++(v,z2) & Perm(w,z1++z2))
proof 
 cut Perm(x,v,w) <-> Perm((v,w),x)
  weak Perm(x,v,w) <-> Perm((v,w),x)
   use Perm_pair_left_conc.0; v; w; x proved..
  weak* Perm((v,w),x) <-> ~\e z1\e z2(x = z1++(v,z2) & Perm(w,z1++z2))
   split Perm(x,v,w) <-> ~Perm((v,w),x).1,0,2,0,0
    use Perm_sym; v,w; x proved.
    use Perm_sym; x; v,w proved.....

thm Perm_pair_right
  Perm(y,v,w) <-> \e z(Perm(z,w) & Inserted(y,z,v))
proof 
 use Perm_pair_right_conc.0; y; v; w
  weak Perm(y,v,w) <-> \e z1\e z2(y = z1++(v,z2) & Perm(w,z1++z2))
   split* \e z1\e z2(y = z1++(v,z2) & Perm(w,z1++z2)) <-> 
          \e z(Perm(z,w) & Inserted(y,z,v)).2,0,0
    eigen \e z1\e z2(y = z1++(v,z2) & Perm(w,z1++z2)).0; z1,z2
     weak y = z1++(v,z2)
      use Perm_sym; w; z1++z2
       weak Perm(w,z1++z2)
        inst* \e z(Perm(z,w) & Inserted(z1++(v,z2),z,v)); z1++z2
         weak Perm(z1++z2,w)
          weak* \e z(Perm(z,w) & Inserted(z1++(v,z2),z,v))
           exp Inserted; z1++(v,z2),z1++z2,v
            inst* \e z3\e z4(z1++z2 = z3++z4 & z1++(v,z2) = z3++(v,z4)); z1; z2 proved.........
    eigen \e z(Perm(z,w) & Inserted(y,z,v)).0; z
     exp Inserted; y,z,v
      eigen \e z1\e z2(z = z1++z2 & y = z1++(v,z2)).0; z1,z2
       weak z = z1++z2
        use Perm_sym; z1++z2; w
         weak Perm(z1++z2,w)
          inst* \e z3\e z4(z1++(v,z2) = z3++(v,z4) & Perm(w,z3++z4)); z1; z2 proved...........

rem 
  \para \bf  Definition and basic properties of list partitions.  \end 

fun Union 'Tex_f1_ln_union'
  Union(0) = 0
  Union(v,w) = v++Union(w)

pred/2 Concp 'Tex_p2_ln_concp'
  Concp(y,x) <-> Union(y) = x & 0 !in y

thm Concp_zero_right
  Concp(y,0) <-> y = 0
proof 
 exp Concp; y,0
  case Ln; y @ 0; v,w
   proved
   inv* v != 0 proved....

thm Concp_pair_right
  Concp(y,v,w) <-> 
  \e z(Concp(z,w) & y = (v,0),z) \/ \e z1\e z2(Concp((z1,z2),w) & y = (v,z1),z2)
proof 
 split* Concp(y,v,w) <-> 
        \e z(Concp(z,w) & y = (v,0),z) \/ 
        \e z1\e z2(Concp((z1,z2),w) & y = (v,z1),z2).2,0,1,(4,0,0,0),0
  exp Concp; y,v,w
   case Ln; y @ 0; v1,w1
    proved
    case Ln; v1 @ 0; v2,v3
     proved
     cut v3 = 0
      inst* \e z(Concp(z,w) & w1 = z); w1
       exp Concp; w1,w proved..
      inst* \e z1(\e z2(Concp((z1,z2),w) & w1 = z2) & v3 = z1):0,3,0,1,0; v3; w1
       exp Concp; (v3,w1),w proved......
  eigen \e z(Concp(z,w) & y = (v,0),z).0; z
   exp Concp; z,w
    exp Concp; ((v,0),z),v,w proved...
  eigen \e z1\e z2(Concp((z1,z2),w) & y = (v,z1),z2).0; z1,z2
   exp Concp; (z1,z2),w
    exp Concp; ((v,z1),z2),v,w proved.....

